package com.sleepycat.je.dbi;

import com.sleepycat.je.DatabaseEntry;
import com.sleepycat.je.DatabaseException;
import com.sleepycat.je.OperationStatus;
import com.sleepycat.je.tree.BIN;
import com.sleepycat.je.tree.DBIN;
import com.sleepycat.je.txn.LockType;

public privileged aspect DebugCursorVerification {

	before(CursorImpl ci) throws DatabaseException: 
		target(ci) &&
		(execution(void CursorImpl.hook_beginGetNextDuplicateLoop(DBIN)) ||
		 (call(OperationStatus CursorImpl.getNextDuplicate(DatabaseEntry, DatabaseEntry, LockType, boolean)) 
				 && withincode(* CursorImpl.getNextWithKeyChangeStatus(..)))) {

		if (CursorImpl.DEBUG) {
			ci.verifyCursor(ci.dupBin);
		}
	}

	before(CursorImpl ci) throws DatabaseException : 
		target(ci) && call(void CursorImpl.hook_verifyBin(BIN)) {

		if (CursorImpl.DEBUG) {
			ci.verifyCursor(ci.bin);
		}
	}

	before(CursorImpl ci) throws DatabaseException :
		target(ci) && execution(void CursorImpl.checkCursorState(boolean)) {

		if (CursorImpl.DEBUG) {
			if (ci.status == CursorImpl.CURSOR_INITIALIZED) {
				if (ci.bin != null) {
					ci.verifyCursor(ci.bin);
				}
				if (ci.dupBin != null) {
					ci.verifyCursor(ci.dupBin);
				}
			}
		}
	}

}
